Ruby - Bug #12120

[target/sh4] error: 'asm’ operand requires impossible reload
02/27/2016 02:23 PM - glaubitz (John Paul Adrian Glaubitz)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:
UNKNOWN

Description

Hello!

ruby2.3 fails to build from source on sh4 (Hitachi/Renesas SuperH), the build fails with 1:

gcc -mieee —-g -02 —-fstack-protector-strong -Wformat -Werror=format-security —-fPIC -D_FORTIFY_SOUR
CE=2 -fstack-protector —-fno-strict-overflow —-fvisibility=hidden -DRUBY_EXPORT -Wdate-time -D_FORTI
FY_SOURCE=2 -I. -I.ext/include/sh4-linux-gnu -I./include -I. -0 vm.o0 -C vm.cC

In file included from probes.h:10:0,

from vm.c:23:

vm_exec.c: In function 'vm_exec_core':
probes.h:21:1: error: 'asm' operand requires impossible reload

DTRACE_PROBE4 (ruby, method__entry, argl, arg2, arg3, arg4)

A

This appears to be a regression in ruby from version 2.2 to 2.3 since ruby2.2 builds fine on the exact same machine 2. Let me know
if you need any more input. The logs can be directly viewed in 1 and 2 and you can set up your own sh4 chroot with the
documentation in 3.

Thanks,
Adrian

History

#1 - 02/29/2016 01:55 AM - nobu (Nobuyoshi Nakada)
- Description updated

- Status changed from Open to Feedback

What constraints does DTRACE_PROBE4 macro have?

#2 - 03/24/2016 08:25 AM - glaubitz (John Paul Adrian Glaubitz)
Hi Nobuyosh!

Nobuyoshi Nakada wrote:

What constraints does DTRACE_PROBE4 macro have?

Sorry for the late reply, | apparently didn't get a notification.
I'm not sure where to retrieve that information. Can you point me to where that macro is defined?

Thanks,
Adrian

#3 - 03/26/2016 06:26 PM - glaubitz (John Paul Adrian Glaubitz)
Hi!
Just a quick update: | have started a discussion in the gcc bug tracker [1] since | am not so sure whether this is actually a bug in ruby or in gcc. One

of the gcc developers, Oleg Endo, has suggested adding "-mlra" to gcc to use the local register allocator and it turns out that vm.c will then build
without any issue.
https://buildd.debian.org/status/fetch.php?pkg=ruby2.3&arch=sh4&ver=2.3.0-2&stamp=1455247013
https://buildd.debian.org/status/fetch.php?pkg=ruby2.2&arch=sh4&ver=2.2.4-1&stamp=1454943020
https://buildd.debian.org/status/fetch.php?pkg=ruby2.3&arch=sh4&ver=2.3.0-2&stamp=1455247013
https://buildd.debian.org/status/fetch.php?pkg=ruby2.2&arch=sh4&ver=2.2.4-1&stamp=1454943020
https://wiki.debian.org/SH4/sbuildQEMU

However, adding -mlra as a global gcc option for the whole ruby tree will trigger a different compiler problem. So, unless there is a simple way to pass
-mira to gcc for just vm.c, | haven't found a solution yet.

I'll wait for more feedback from the gcc developers though as | have provided them with the preprocessed source for vm.c. Maybe they'll figure out
this is something to be fixed in gcc.

Thanks,
Adrian

[1] https://gcc.gnu.org/bugzilla/show_bug.cqi?id=70416

#4 - 07/24/2019 05:52 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Feedback to Closed
https://gcc.gnu.org/bugzilla/show_bug.cgi?id=70416
http://www.tcpdf.org

